//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.

#ifndef MTL4TYPES_H
#define MTL4TYPES_H
#include <boost/numeric/mtl/mtl.hpp>

namespace AMDiS {

  namespace MTLTypes {
    typedef double value_type;
    typedef unsigned size_type;
    typedef mtl::matrix::parameters<mtl::row_major, mtl::index::c_index, mtl::non_fixed::dimensions, false, size_type> para;
    typedef mtl::matrix::compressed2D< value_type, para > MTLMatrix;
    typedef mtl::vector::dense_vector< value_type > MTLVector;
  }

}

#endif

