//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.


#include "parallel/FeSpaceMapping.h"

namespace AMDiS {

  using namespace std;

  void GlobalDofMap::clear()
  {
    dofMap.clear();
    nRankDofs = 0;
    nOverallDofs = 0;
    rStartDofs = 0;
  }


  void GlobalDofMap::update(bool add)
  {
    for (DofMapping::iterator it = dofMap.begin(); it != dofMap.end(); ++it)
      if (it->second == -1)
	it->second = nRankDofs++;
    
    nOverallDofs = 0;
    rStartDofs = 0;
    mpi::getDofNumbering(*mpiComm, nRankDofs, rStartDofs, nOverallDofs);
    
    if (add)
      addOffset(rStartDofs);
  }


  void GlobalDofMap::addOffset(int offset)
  {
    for (DofMapping::iterator it = dofMap.begin(); it != dofMap.end(); ++it)
      it->second += offset;
  }

}
